'use strict';

module.exports.make = function make(deps) {
	if (undefined === deps) deps = {};

	var vows 	= deps.vows 	|| require('vows'),
		assert 	= deps.assert 	|| require('assert'),
		njson	= deps.njson 	|| require(__dirname + '/../lib/norris-json');

	var suite = vows.describe('NORRIS-JSON Attach to global JSON object Unit Test');

	suite.addBatch({
		'GIVEN that we want to test if attaching to global JSON works' : {
			topic : function topic() {
				var nj = njson.make();
				nj.attachToGlobal();
				return true;
			},

			'THEN the JSON global object should have load()' : function testResults() {
				assert.isFunction(JSON.load);
			},

			'THEN the JSON global object should have loadSync()' : function testResults() {
				assert.isFunction(JSON.loadSync);
			}
		}
	});

	return suite;
}